.subckt dfe_2_4_rx nvdd outp ngnd outn DFE_out bitp=400p 
+ cf0=1 cf1=-0.111 cf2=-0.085 cf3=0.038 cf4=-0.128 cf5=-0.024
+ padcap=1p

* cf0 and cf1 are forward coefficients
* all others are backward coefficients

cp outp ngnd 'padcap'
cn outn ngnd 'padcap'
rp outp nvdd 50
rn outn nvdd 50

* rx is the output node
vshort rx DFE_out 0

erxin rxin ngnd v='v(outp, outn)'

* .node_param rxin name=rxin print

erxdc rxdc ngnd v='((cf0 + cf1) * v(rxin, ngnd)) /(1 - cf2 - cf3 - cf4 - cf5)'

rrxdc rxdc ngnd 1e6

xrx1 rxin rx1 ngnd delayin del='bitp'
xrx2 rx rx2 ngnd delayin del='1*bitp'
xrx3 rx rx3 ngnd delayin del='2*bitp'
xrx4 rx rx4 ngnd delayin del='3*bitp'
xrx5 rx rx5 ngnd delayin del='4*bitp'

erx rx ngnd v='if (time <= 0) (v(rxdc, ngnd)) else (cf0 * v(rxin, ngnd) + cf1 * v(rx1, ngnd) + cf2 * v(rx2, ngnd) + cf3 * v(rx3, ngnd) + cf4 * v(rx4, ngnd) + cf5 * v(rx5, ngnd))'

* .node_param rx name=(RXin_diff name(outp) _ name(outn) _diff) print

.subckt delayin in1 in2 ngnd del=0
ein1 in2 ngnd pwl in1 ngnd delay=del
datapoints vv
0 0
1 1
end vv
r in2 ngnd 1e6
.ends delayin

.ends dfe_2_4_rx
