.subckt gatemod 1 2 3 4 5 6 7 ibis_file=ibis_models.inc BUFF=buffer1 

* For the bdrvr, nodes 8 and 9 dynamically scale the pullup and pulldown
* curves respectively in real-time.  These nodes are multiplied according
* to the tables below.  This technique can be used on any IBIS buffer. 

bdrvr 1 2 3 4 5 6 7 8 9 10 11 model=BUFF file=ibis_file 

* do not scale power and ground clamps, in this template

v 10 0 1
v 11 0 1

* scale 3.3V pullup curve by as much as 1.3 for +300mV 
* and 0.78 for -300mV 

eup 8 0 pwl 1 0
datapoints vi
3.6 1.3
3.5 1.2
3.4 1.1
3.3 1.0
3.2 0.92
3.1 0.85
3.0 0.78
end vi

* scale pulldown VI curve for ground bounce, 
* positive bounce weakens, negative bounce
* multiplies the curve as shown since the gate 
* voltage is greater

rstable 90 0 0.01

edn 9 0 pwl 3 90
datapoints vi
0.3 0.89
0.2 0.92
0.1 0.96
0.0 1.00
-0.1 1.05
-0.2 1.09
-0.3 1.13
end vi

* you can print internal nodes, such as...
* .node_param 3 name=(name(2).die_gnd) print
.node_param 9 name=(name(2).gnd_scaler) print

.ends gatemod
